<script type="text/x-red" data-template-name="knx-controller">
    <div class="form-row">
      <label for="node-config-input-ipAddr"><i class="icon-bookmark"></i>IP address</label>
      <input type="text" id="node-config-input-ipAddr">
    </div>
    <div class="form-row">
      <label for="node-config-input-ipPort"><i class="icon-bookmark"></i>IP port</label>
      <input type="text" id="node-config-input-ipPort">
    </div>
    <div class="form-row">
      <label for="node-config-input-physAddr"><i class="icon-bookmark"></i>Physical address</label>
      <input type="text" id="node-config-input-physAddr">
    </div>
    <div class="form-row">
      <label for="node-config-input-incomingWrite"><i class="icon-bookmark"></i>Routing</label>
      <input type="checkbox" id="node-config-input-incomingWrite">
    </div>
</script>

<script type="text/x-red" data-help-name="knx-controller">
  <b>Knx controller</b> configuration:<br/>
  <ul>
      <li><b>IP address</b> ip address of your <b>Knx <i>Ip interface</i>, <i>Ip router</i> or <i>Logic machine</i> </b> or if you want to use Multicast, write your multicast ip for example, <b>224.0.23.12</b> </li>
      <li><b>IP port</b> port to use for ip connection, default is 3671 or <b>blank</b> </li>
      <li><b>Physical address</b> address to use for this <b>knx interface</b> </li>
      <li><b>Routing</b> function to write incoming msg from other <b>knx-interface</b> inside to this <b>knx interface</b> </li>
  </ul>
  <p>
    <b>NOTE:</b> before you select your file .esf, press 'UPDATE'->'DONE'->'DEPLOY' for apply changes to node <br>
  </p>
</script>

<script type="text/x-red" data-template-name="knx-decode">
  <div class="form-row">
    <label for="node-config-input-ipAddr"><i class="icon-bookmark"></i>IP address</label>
    <input type="text" id="node-config-input-ipAddr">
  </div>
  <div class="form-row">
    <label for="node-config-input-ipPort"><i class="icon-bookmark"></i>IP port</label>
    <input type="text" id="node-config-input-ipPort">
  </div>
  <div class="form-row">
    <label for="node-config-input-physAddr"><i class="icon-bookmark"></i>Physical address</label>
    <input type="text" id="node-config-input-physAddr">
  </div>
  <div class="form-row">
    <label for="node-config-input-incomingWrite"><i class="icon-bookmark"></i>Routing</label>
    <input type="checkbox" id="node-config-input-incomingWrite">
  </div>
</script>

<script type="text/x-red" data-help-name="knx-decode">
<b>Knx decode</b> configuration:<br/>
<ul>
    <li><b>msg.payload.dpt</b> is the dpt <b>needed</b> for decode value in <b>msg.payload.value</b></li>
    <li><b>msg.payload.value</b> is the value to be decoded</li>
</ul>
<p>
  <b>NOTE:</b> if you don't have msg.payload.value or msg.payload.dpt the value can't be decoded <br>
</p>
</script>

<script type="text/x-red" data-template-name="knx-interface">
    <div class="form-row">
      <label for="node-input-name"><i class="icon-tag"></i> Name</label>
      <input type="text" id="node-input-name" placeholder="Name">
    </div>
    <div class="form-row">
      <label for="node-input-controller"><i class="icon-bookmark"></i>Connection</label>
      <input type="text" id="node-input-controller">
    </div>
    <div class="form-row">
      <label for="input-emitter-check" >Emitter enable</label>
      <input type="checkbox" style="width: 20px;" id="input-emitter-check">
    </div>
    <div id="input-emitter-row">
      <div class="form-row">
        <label for="input-emitter-name">Emitter</label>
        <input type="text" id="input-emitter-name">
      </div>
      <div class="form-row">
        <label for="input-emitter-channel">Event</label>
        <input type="text" id="input-emitter-channel">
      </div>
      <div class="form-row">
        <label for="input-emitter-event">Sub-event</label>
        <input type="text" id="input-emitter-event">
      </div>
    </div>
</script>

<script type="text/x-red" data-help-name="knx-interface">
    <p>
      <b>knx-interface</b> Use this to <b>inject, read and routing</b> knx events.<br/>
    <b>msg.topic</b> will be:
    <ul>
      <li>'read': when need read value from bus</li>
      <li>'write': when need write to this</li>
      <li>'raw': when need write raw buffer value, for example for write 18.4 °C you need pass <b>Buffer.from('0730', 'hex')</b> to msg.payload.value. <br> for write raw buffer with especific bitlength use msg.payload.bit with your bitlength and <b>Buffer.from('01', 'hex')</b> into msg.payload.value </li>
    </ul>
    <b>msg.payload</b> will be an object with the following properties:
    <ul>
      <li>srcphy: source <b>physical</b> address (eg.'1.1.100')</li>
      <li>dstgad: destination <b>group</b> address (eg.'1/2/3')</li>
      <li>value: the actual value received (<b>NOTE: just a raw Buffer</b>)</li>
    </ul>
    You can use only one node for all functions, this node have a mechanism to protect connection with your <b>knx</b> <i>ip interface, ip router and logic machine (LM)</i>.<br>
    </p>
</script>

<script type="text/javascript">
  RED.nodes.registerType('knx-controller', {
    category: 'config',
    defaults: {
      ipAddr: { value: "224.0.23.12", required: false },
      ipPort: { value: 3671, required: false, validate: RED.validators.number() },
      physAddr: { value: "15.15.15", required: false, validate: RED.validators.regex(/^\d+\.\d+\.\d+$/) },
      incomingWrite: { value: false, required: false }
    },
    label: function () {
      return `${this.ipAddr}:${this.ipPort} phys:${this.physAddr}`;
    },
    oneditprepare: function () {

    }
  })
</script>

<script type="text/javascript">
  RED.nodes.registerType('knx-decode', {
    category: 'knx',
    color: '#20FDF0',
    defaults: {
      name: { value: "" },
      dpt: { value: "null", required: false },
      specific: { value: false, required: false }
    },
    inputs: 1,
    outputs: 1,
    icon: "knx.svg",
    inputLabels: "Write, Read",
    outputLabels: "Telegram",
    label: function () {
      return this.name || `knx decode`;
    },
    oneditprepare: function () {

    }
  })
</script>

<script type="text/javascript">
  RED.nodes.registerType('knx-interface', {
    category: 'knx',
    color: '#C0DEED',
    defaults: {
      name: { value: "" },
      controller: { value: "", type: "knx-controller" },
      externalEvents: { value: {} }
    },
    inputs: 1,
    outputs: 1,
    icon: "knx.svg",
    inputLabels: "Write, Read",
    outputLabels: "Telegram",
    label: function () {
      return this.name || `knx interface`;
    },
    oneditprepare: function () {
      if (!this.externalEvents) {
        this.externalEvents = {};
      }

      if (this.externalEvents.enable) {
        $("#input-emitter-check").prop('checked', true);
        $("#input-emitter-name").val(this.externalEvents.name);
        $("#input-emitter-channel").val(this.externalEvents.channel);
        $("#input-emitter-event").val(this.externalEvents.event);
        $("#input-emitter-row").show();
      } else {
        $("#input-emitter-row").hide();
      }

      $("#input-emitter-check").change();

      $("#input-emitter-check").on("change", (e) => {
        if (e.target.checked) {
          this.externalEvents.enable = true;
          $("#input-emitter-name").val(this.externalEvents.name);
          $("#input-emitter-channel").val(this.externalEvents.channel);
          $("#input-emitter-event").val(this.externalEvents.event);
          $("#input-emitter-row").show();
        }
        else {
          this.externalEvents.enable = false;
          $("#input-emitter-row").hide();
        }
      });
    },
    oneditsave: function () {
      if ($("#input-emitter-check").prop("checked")) {
        this.externalEvents.name = $("#input-emitter-name").val();
        this.externalEvents.channel = $("#input-emitter-channel").val();
        this.externalEvents.event = $("#input-emitter-event").val();
      }
    }
  })
</script>